<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( zalogowany() )
	przekierowanie();

if ( $_SERVER['REQUEST_METHOD'] == 'POST' and isset($_POST['formularzLogowania']) ) {

	// resetowanie hasła

	if ( isset($_GET['resetowanieHasla']) and odczytKonf('resetowanieHasla') ) {

		include_once( SYSTEM . '/funkcje/password.php' );

		if (
			!empty($_POST['administratorNazwa']) and !empty($_POST['email']) and
			password_verify( $_POST['administratorNazwa'], odczytKonf('administratorNazwa') ) and
			$_POST['email'] == odczytKonf('email')
		   ) {

			$losoweHaslo = rand(100,999) . rand(100,999) . rand(1000,9999);

			if ( wiadomosc( 'Witaj!' . "\n\n" . 'Hasło panelu administracyjnego witryny ' . odczytKonf('adres') . ' zostało zresetowane. Nowe hasło to poniższy ciąg cyfr.' . "\n\n" . $losoweHaslo . "\n\n" . odczytKonf('adres') . '/' . odczytKonf('panelAdminAdres') . '?zresetowanoHaslo=' . base64_encode($losoweHaslo) . "\n\n" . 'Zaloguj się nim, korzystając z powyższego odnośnika, i zmień je na łatwiejsze do zapamiętania.' . "\n\n" . 'Miłego dnia!', 'Resetowanie hasła' ) ) {

				setcookie( 'WT_resetowanie', password_hash( $losoweHaslo, PASSWORD_BCRYPT ), time()+1800 );

				// na adres e-mail zostanie wysłany mail z wygenerowanym hasłem oraz link do strony logowania, którego kliknięcie zmienia hasło na wygenerowane...

				komunikat('dob.Nowe hasło zostało wysłane. Sprawdź swoją pocztę e-mail.');
				$zablokujZresetowanieHasla = true;

			}

			else
				komunikat('zle.Nie udało się wysłać wiadomości e-mail z nowym hasłem. Hasło nie zostało zmienione.');

		}

		else
			komunikat('zle.Wprowadzone dane są niewłaściwe.');

	}

	// logowanie

	else {

		if ( $_POST['czasZalogowania'] == 'doKoncaDoby' )
			$czasZalogowania = mktime( 0, 0, 0, date('m'), date('d')+1, date('Y') );
		else {
			$tablicaCzasu    = array( 'kwadrans' => 900, 'godzina' => 3600, 'jedenDzien' => 86400, 'dwaTygodnie' => 1209600 );
			$czasZalogowania = time() + $tablicaCzasu[ $_POST['czasZalogowania'] ];
		}

		include_once( SYSTEM . '/funkcje/password.php' );

		if (
			!empty($_POST['administratorNazwa']) and !empty($_POST['administratorHaslo']) and
			password_verify( $_POST['administratorNazwa'], odczytKonf('administratorNazwa') ) and
			password_verify( $_POST['administratorHaslo'], odczytKonf('administratorHaslo') )
		   ) {

			$identyfikatorLogowania = rand(100,999) . rand(100,999) . $czasZalogowania;

			setcookie( 'WT_administracja', $identyfikatorLogowania, $czasZalogowania );
			zapisKonf( array( 'identyfikatorLogowania' => password_hash( $identyfikatorLogowania, PASSWORD_BCRYPT ) ) );

			if ( odczytKonf('statystyki') )
				setcookie( 'WT_statystyki', '1', $czasZalogowania );

			if ( defined('ID') )
				przekierowanie($_SERVER['REQUEST_URI']);
			elseif ( isset($_GET['zresetowanoHaslo']) )
				przekierowanie('?id=ustawieniaSystemu&zmianaHasla');
			else
				przekierowanie();

		}

		else
			komunikat('zle.Wprowadzone dane logowania są niewłaściwe.');

	}

}

if ( defined('ID') and !komunikat() ) {

	if ( $_SERVER['REQUEST_METHOD'] == 'POST' and !isset($_POST['formularzLogowania']) ) {
		if ( ID == 'ustawieniaStrony' or ID == 'edycjaStrony' )
			komunikat('zle.Sesja wygasła. Należy zalogować się ponownie. Zawartość wprowadzona przed chwilą prawdopodobnie została utracona.');
		else
			komunikat('zle.Sesja wygasła. Należy zalogować się ponownie. Ustawienia wprowadzone przed chwilą prawdopodobnie zostały utracone.');
	}

	else
		komunikat('xxx.Po zalogowaniu nastąpi przekierowanie do właściwej strony.');

}

if ( !empty($_GET['zresetowanoHaslo']) and odczytKonf('resetowanieHasla') ) {

	include_once( SYSTEM . '/funkcje/password.php' );

	// ...hasło z $_GET zostanie porównane z zahaszowanym hasłem z ciasteczka, które jest wtedy usuwane

	if ( !empty($_COOKIE['WT_resetowanie'])
		and password_verify( base64_decode($_GET['zresetowanoHaslo']), $_COOKIE['WT_resetowanie'] ) ) {
		setcookie( 'WT_resetowanie', '', 0 );
		zapisKonf( array('administratorHaslo' => password_hash( base64_decode($_GET['zresetowanoHaslo']), PASSWORD_BCRYPT ) ) );
		komunikat('xxx.Zaloguj się hasłem otrzymanym przez pocztę e-mail.');
	}

	else
		komunikat('zle.Zresetowane hasło straciło ważność. Wygeneruj hasło ponownie.');

}

if ( isset($_GET['wylogowano']) and !komunikat() ) {
	komunikat('dob.Wylogowano się z panelu administracyjnego.');
	header( 'Refresh: 2; url=' . odczytKonf('adres') );
}

if ( isset($_GET['resetowanieHasla']) and !odczytKonf('resetowanieHasla') )
	komunikat('zle.Funkcja resetowania hasła została zablokowana.');

$listaCzasuLogowania = array( 'kwadrans' => 'Kwadrans', 'godzina' => 'Jedna godzina', 'doKoncaDoby' => 'Do końca doby', 'jedenDzien' => 'Jeden dzień', 'dwaTygodnie' => 'Dwa tygodnie' );

$CHOWAC_SIE_KTO_MOZE = true;
include (SYSTEM.'/admin/naglowek.php');
?>
<h2>Panel administracyjny</h2>

<form method="post">

<?php
if ( isset($_GET['resetowanieHasla']) and odczytKonf('resetowanieHasla') ) {
?>

<table>
	<tr> <td>Nazwa użytkownika:</td> <td><input type="text" <?php wylaczElement(isset($zablokujZresetowanieHasla),true) ?> name="administratorNazwa" /></td> </tr>
	<tr> <td>Adres e-mail:</td> <td><input type="text" <?php wylaczElement(isset($zablokujZresetowanieHasla),true) ?> name="email" /></td> </tr>
</table>

<p class="informacja">Na podany adres e-mail zostanie przesłana wiadomość z&nbsp;nowym, losowo wygenerowanym hasłem, które należy po zalogowaniu czym prędzej zmienić.</p>

<p class="przyciskWysylania"><input type="submit" <?php wylaczElement(isset($zablokujZresetowanieHasla),true) ?> value="Zresetuj hasło" /></p>

<?php
}
else {
?>

<table>
	<tr> <td>Nazwa użytkownika:</td> <td><input type="text" name="administratorNazwa" <?php wylaczElement(isset($_GET['wylogowano']),true) ?> /></td> </tr>
	<tr> <td>Hasło:</td> <td><input type="password" name="administratorHaslo" <?php wylaczElement(isset($_GET['wylogowano']),true) ?> /></td> </tr>
</table>

<table>
	<tr> <td>Czas zalogowania:</td> <td><select <?php wylaczElement(isset($_GET['wylogowano']),true) ?> name="czasZalogowania"><?php generujListeWyboru( $listaCzasuLogowania, odczytKonf('domyslnyCzasLogowania') ) ?></select></td> </tr>
</table>

<p class="przyciskWysylania"><input type="submit" value="Zaloguj się" <?php wylaczElement(isset($_GET['wylogowano']),true) ?> /></p>

<?php
}
?>

<input type="hidden" name="formularzLogowania" value="1" />

</form>

<?php
include (SYSTEM.'/admin/stopka.php');