<?php
// WizyTówka 4
if (!defined('WT')) exit();


// funkcja wyświetlania błędu krytycznego i zapisu dziennika błędów

function wychwytywanieBledow ( $poziom, $tresc, $plik, $linia ) {

	$bledyPHP = array( 1 => 'E_ERROR', 2 => 'E_WARNING', 8 => 'E_NOTICE', 256 => 'E_USER_ERROR', 512 => 'E_USER_WARNING', 1024 => 'E_USER_NOTICE' );
	$poziom = (isset($bledyPHP[$poziom])) ? $bledyPHP[$poziom] : 'nieznany (integer: '.$poziom.')';
	$plik = basename(dirname($plik)) . '/' . basename($plik);

	$komunikat = "Błąd:\t$poziom\nPlik:\t$plik\nLinia:\t$linia\nTreść:\t$tresc";

	@file_put_contents(
		DANE . '/wtk/bledy.log',
		"\n\n" . date('Y-m-d H:i:s') . ' —————— ' . "\n" . $komunikat,
		FILE_APPEND
	);

	if ( !file_exists( DANE . '/wtk/konfiguracja.wtk' ) or odczytKonf('bledyKrytyczne') or defined('BLEDY_KRYTYCZNE') ) {
?>

<!doctype html>

<meta charset="utf-8" />

<div style="background: #EEEEEE !important; position: fixed !important; left: 0 !important; right: 0 !important; top: 0 !important; bottom: 0 !important; opacity: 0.6 !important; z-index: 996 !important; padding: 0 !important; margin: 0 !important; height: auto !important;">&nbsp;</div>

<div style="padding: 0; margin: 0; height: auto; font: 21px 'Source Sans Pro', Arial, sans-serif; position: fixed; top: 0; left: 0; right: 0;  width: 500px; margin: auto; margin-top: 8%; background: #FBFBFB; box-shadow: 0 0 4px #909090; cursor: default; text-shadow: none; z-index: 997; opacity: 1 !important; display: block;">
	<h1 class="cb5e100e5a9a3e7f6" style="background: none; height: auto; widht: auto; text-indent: 0; color: #FF0000; margin: 0; padding: 0.4em; text-align: center; font-size: 2em; background: #f2f2f2; font-weight: normal; display: block; float: none; width: auto;">Błąd krytyczny</h1>
	<p  style="color: #FF0000; margin: 0; padding: 1em 0; text-align: center; font-size: 0.8em; background: #F7F7F7; display: block; float: none; width: auto;">Działanie systemu zostało przerwane, ponieważ wystąpił błąd.<br />Odśwież stronę i spróbuj ponownie lub udaj się wstecz.</p>
	<p style="color: #FF0000; margin: 0; padding: 0.7em 1em; display: block; float: none; width: auto; overflow-x: auto; white-space: pre-wrap; text-align: left;"><?php echo $komunikat ?></p>
	<p  style="color: #FF0000; margin: 0; padding: 0.5em; text-align: center; background: #f2f2f2; font-size: 0.6em; display: block; float: none; width: auto;">WizyTówka <?php echo WERSJA ?></p>
</div>
<?php
	exit();
	}

}